{
   Orao emulator - DumpForm

   Copyright (C) 2006 Josip Peruanec <josip.perusanec@foing.hr>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit DumpForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, IdGlobal;

type
  TfrmDump = class(TForm)
    Bevel1: TBevel;
    ListBox: TListBox;
    sbMinus: TSpeedButton;
    sbPlus: TSpeedButton;
    btnZatvori: TBitBtn;
    Timer: TTimer;
    Label1: TLabel;
    lblFlags: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    lblPC: TLabel;
    lblNMI: TLabel;
    lblRES: TLabel;
    lblIRQ: TLabel;
    Bevel2: TBevel;
    procedure TimerTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure sbMinusClick(Sender: TObject);
    procedure sbPlusClick(Sender: TObject);
    procedure btnZatvoriClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    procedure EnableDisable;
  public
    { Public declarations }
  end;

var
  frmDump: TfrmDump;

implementation

uses MainForm;

{$R *.dfm}

procedure TfrmDump.FormShow(Sender: TObject);
begin
  EnableDisable;
  ListBox.Items.Clear;
  Timer.Enabled:=True;
end;

procedure TfrmDump.TimerTimer(Sender: TObject);
var
  i,j,a: integer;
  s: string;
begin
  ListBox.Items.Clear;
  for i:= 0 to 15 do begin
    a:=frmMain.DumpFrom+i*8;
    s:=IntToHex(a,4)+': ';
    for j:= 0 to 7 do begin
      s:=s+IntToHex(frmMain.Mem[a+j],2);
      if j<7 then s:=s+' ';
    end;
    ListBox.Items.Add(s);
  end;
  lblFlags.Caption:=Copy(IntToBin(frmMain.cpu.P),25,8);
  lblPC.Caption:=IntToHex(frmMain.cpu.PC.W,4);
  lblNMI.Caption:=IntToHex(frmMain.Mem[$FFFA]+256*
    frmMain.Mem[$FFFB],4);
  lblRES.Caption:=IntToHex(frmMain.Mem[$FFFC]+256*
    frmMain.Mem[$FFFD],4);
  lblIRQ.Caption:=IntToHex(frmMain.Mem[$FFFE]+256*
    frmMain.Mem[$FFFF],4);
end;

procedure TfrmDump.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DoubleBuffered:=True;
  Timer.Enabled:=False;
end;

procedure TfrmDump.sbMinusClick(Sender: TObject);
begin
  frmMain.DumpFrom:=frmMain.DumpFrom-128;
  EnableDisable;
end;

procedure TfrmDump.sbPlusClick(Sender: TObject);
begin
  frmMain.DumpFrom:=frmMain.DumpFrom+128;
  EnableDisable;
end;

procedure TfrmDump.btnZatvoriClick(Sender: TObject);
begin
  frmDump.Close;
end;

procedure TfrmDump.EnableDisable;
begin
  sbMinus.Enabled:=frmMain.DumpFrom>0;
  sbPlus.Enabled:=frmMain.DumpFrom<$FF80;
end;

procedure TfrmDump.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key in [VK_LEFT]) and sbMinus.Enabled then
    sbMinusClick(self);
  if (Key in [VK_RIGHT]) and sbPlus.Enabled then
    sbPlusClick(self);
end;

end.
