{
   Orao emulator - KazetaForm

   Copyright (C) 2006 Josip Peruanec <josip.perusanec@foing.hr>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit KazetaForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons;

type
  TfrmKazeta = class(TForm)
    ListBox: TListBox;
    lblKazeta: TLabel;
    btnOtvori: TBitBtn;
    btnZatvori: TBitBtn;
    btnOK: TBitBtn;
    OpenDialog1: TOpenDialog;
    procedure FormShow(Sender: TObject);
    procedure btnOtvoriClick(Sender: TObject);
    procedure UcitajKazetu;
    procedure btnZatvoriClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure ListBoxDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmKazeta: TfrmKazeta;
  tf: File of Byte;
  TapeHdr: array[0..360] of Byte;
  br: integer;

implementation

uses MainForm;

{$R *.dfm}

procedure TfrmKazeta.FormShow(Sender: TObject);
begin
  ListBox.Items.Clear;
  lblKazeta.Caption:=frmMain.TapeName;
  if frmMain.TapeName <> '' then begin
    UcitajKazetu;
  end;
end;

procedure TfrmKazeta.btnOtvoriClick(Sender: TObject);
begin
  OpenDialog1.DefaultExt:='tap';
  OpenDialog1.Filter:='Tap datoteke (*.tap)|*.tap';
  OpenDialog1.FilterIndex:=1;
  OpenDialog1.InitialDir:=ExtractFileDir(ParamStr(0));
  if (OpenDialog1.Execute) then begin
    frmMain.TapeName:=OpenDialog1.FileName;
    lblKazeta.Caption:=frmMain.TapeName;
    ListBox.Items.Clear;
    UcitajKazetu;
  end;
end;

procedure TfrmKazeta.UcitajKazetu;
var
  i,j,k: integer;
  s: string;
begin
  AssignFile(tf,frmMain.TapeName);
  Reset(tf);
  BlockRead(tf,TapeHdr,360,br);
  Reset(tf);
  BlockRead(tf,frmMain.Tape,1048575,br);
  CloseFile(tf);
  for i:= 0 to 19 do begin
    j:=i*18+3;
    s:='';
    for k:=j to j+9 do s:=s+chr(TapeHdr[k]);
    k:=j+10;
    s:=s+chr(32);
    s:=s+chr(TapeHdr[k]);
    Inc(k);
    if TapeHdr[k-1]=Ord('B') then begin
      s:=s+chr(32);
      s:=s+Format('%3u',[TapeHdr[k]+256*TapeHdr[k+1],4]);
      s:=s+chr(32);
      s:=s+'blokova';
    end else begin
      s:=s+chr(32);
      s:=s+IntToHex(TapeHdr[k]+256*TapeHdr[k+1],4);
      s:=s+chr(32);
      k:=k+2;
      s:=s+IntToHex(TapeHdr[k]+256*TapeHdr[k+1],4);
    end;
    if Copy(s,12,1)<>' ' then
      ListBox.Items.Add(s);
  end;
  ListBox.ItemIndex:=0;
end;

procedure TfrmKazeta.btnZatvoriClick(Sender: TObject);
begin
  frmMain.TapeName:='';
  ListBox.Items.Clear;
end;

procedure TfrmKazeta.btnOKClick(Sender: TObject);
var
  i:integer;
begin
  if ListBox.Items.Count>0 then begin
    i:=ListBox.ItemIndex*18;
    frmMain.TapePok:=TapeHdr[i]+256*TapeHdr[i+1]+65536*TapeHdr[i+2];
  end else begin
    frmMain.TapePok:=0;
  end;
  frmKazeta.Close;
end;

procedure TfrmKazeta.ListBoxDblClick(Sender: TObject);
begin
  btnOkClick(self);
end;

end.
